diff -u -r linux.clean/drivers/scsi/scsi.c linux.new2/drivers/scsi/scsi.c
--- linux.clean/drivers/scsi/scsi.c	Sun Nov  7 16:35:21 1999
+++ linux.new2/drivers/scsi/scsi.c	Sun Nov 14 08:55:35 1999
@@ -1540,39 +1376,61 @@
 	SCpnt->internal_timeout = NORMAL_TIMEOUT;
 	SCpnt->abort_reason = 0;
 	SCpnt->result = 0;
-	internal_cmnd(SCpnt);
+
+	/*
+	 * At this point, we merely set up the command, stick it in the normal
+	 * request queue, and return.  Eventually that request will come to the
+	 * top of the list, and will be dispatched.
+	 */
+	scsi_insert_special_cmd(SCpnt, 0);
 
 	SCSI_LOG_MLQUEUE(3, printk("Leaving scsi_do_cmd()\n"));
 }
 
-/* This function is the mid-level interrupt routine, which decides how
+/*
+ * This function is the mid-level interrupt routine, which decides how
  *  to handle error conditions.  Each invocation of this function must
  *  do one and *only* one of the following:
  *
  *      1) Insert command in BH queue.
  *      2) Activate error handler for host.
  *
- * FIXME(eric) - I am concerned about stack overflow (still).  An interrupt could
- * come while we are processing the bottom queue, which would cause another command
- * to be stuffed onto the bottom queue, and it would in turn be processed as that
- * interrupt handler is returning.  Given a sufficiently steady rate of returning
- * commands, this could cause the stack to overflow.  I am not sure what is the most
- * appropriate solution here - we should probably keep a depth count, and not process
- * any commands while we still have a bottom handler active higher in the stack.
- *
- * There is currently code in the bottom half handler to monitor recursion in the bottom
- * handler and report if it ever happens.  If this becomes a problem, it won't be hard to
- * engineer something to deal with it so that only the outer layer ever does any real
- * processing.
+ * FIXME(eric) - I am concerned about stack overflow (still).  An
+ * interrupt could come while we are processing the bottom queue,
+ * which would cause another command to be stuffed onto the bottom
+ * queue, and it would in turn be processed as that interrupt handler
+ * is returning.  Given a sufficiently steady rate of returning
+ * commands, this could cause the stack to overflow.  I am not sure
+ * what is the most appropriate solution here - we should probably
+ * keep a depth count, and not process any commands while we still
+ * have a bottom handler active higher in the stack.
+ *
+ * There is currently code in the bottom half handler to monitor
+ * recursion in the bottom handler and report if it ever happens.  If
+ * this becomes a problem, it won't be hard to engineer something to
+ * deal with it so that only the outer layer ever does any real
+ * processing.  
  */
 void scsi_done(Scsi_Cmnd * SCpnt)
 {
+	unsigned long flags;
+	int tstatus;
 
 	/*
 	 * We don't have to worry about this one timing out any more.
 	 */
-	scsi_delete_timer(SCpnt);
+	tstatus = scsi_delete_timer(SCpnt);
 
+	/*
+	 * If we are unable to remove the timer, it means that the command
+	 * has already timed out.  In this case, we have no choice but to
+	 * let the timeout function run, as we have no idea where in fact
+	 * that function could really be.  It might be on another processor,
+	 * etc, etc.
+	 */
+	if (!tstatus) {
+		return;
+	}
 	/* Set the serial numbers back to zero */
 	SCpnt->serial_number = 0;
 
@@ -1588,6 +1446,8 @@
 		SCSI_LOG_MLCOMPLETE(1, printk("Ignoring completion of %p due to timeout status", SCpnt));
 		return;
 	}
+	spin_lock_irqsave(&scsi_bhqueue_lock, flags);
+
 	SCpnt->serial_number_at_timeout = 0;
 	SCpnt->state = SCSI_STATE_BHQUEUE;
 	SCpnt->owner = SCSI_OWNER_BH_HANDLER;
@@ -1603,6 +1463,10 @@
 	 * We already have the io_request_lock here, since we are called from the
 	 * interrupt handler or the error handler. (DB)
 	 *
+	 * This may be true at the moment, but I would like to wean all of the low
+	 * level drivers away from using io_request_lock.   Technically they should
+	 * all use their own locking.  I am adding a small spinlock to protect
+	 * this datastructure to make it safe for that day.  (ERY)
 	 */
 	if (!scsi_bh_queue_head) {
 		scsi_bh_queue_head = SCpnt;
@@ -1612,6 +1476,7 @@
 		scsi_bh_queue_tail = SCpnt;
 	}
 
+	spin_unlock_irqrestore(&scsi_bhqueue_lock, flags);
 	/*
 	 * Mark the bottom half handler to be run.
 	 */
@@ -1633,6 +1498,13 @@
  * race condition when scsi_done is called after a command has already
  * timed out but before the time out is processed by the error handler.
  * (DB)
+ *
+ * I believe I have corrected this.  We simply monitor the return status of
+ * del_timer() - if this comes back as 0, it means that the timer has fired
+ * and that a timeout is in progress.   I have modified scsi_done() such
+ * that in this instance the command is never inserted in the bottom
+ * half queue.  Thus the only time we hold the lock here is when
+ * we wish to atomically remove the contents of the queue.
  */
 void scsi_bottom_half_handler(void)
 {
@@ -1640,14 +1512,14 @@
 	Scsi_Cmnd *SCnext;
 	unsigned long flags;
 
-	spin_lock_irqsave(&io_request_lock, flags);
 
 	while (1 == 1) {
+		spin_lock_irqsave(&scsi_bhqueue_lock, flags);
 		SCpnt = scsi_bh_queue_head;
 		scsi_bh_queue_head = NULL;
+		spin_unlock_irqrestore(&scsi_bhqueue_lock, flags);
 
 		if (SCpnt == NULL) {
-			spin_unlock_irqrestore(&io_request_lock, flags);
 			return;
 		}
 		SCnext = SCpnt->bh_next;
@@ -1731,8 +1603,6 @@
 
 	}			/* while(1==1) */
 
-	spin_unlock_irqrestore(&io_request_lock, flags);
-
 }
 
 /*
@@ -1753,9 +1623,7 @@
 	SCpnt->request_bufflen = SCpnt->bufflen;
 	SCpnt->use_sg = SCpnt->old_use_sg;
 	SCpnt->cmd_len = SCpnt->old_cmd_len;
-	SCpnt->result = 0;
-	memset((void *) SCpnt->sense_buffer, 0, sizeof SCpnt->sense_buffer);
-	return internal_cmnd(SCpnt);
+	return scsi_dispatch_cmd(SCpnt);
 }
 
 /*
@@ -1770,32 +1638,14 @@
 	struct Scsi_Host *host;
 	Scsi_Device *device;
 
+	ASSERT_LOCK(&io_request_lock, 0);
+
 	host = SCpnt->host;
 	device = SCpnt->device;
 
 	host->host_busy--;	/* Indicate that we are free */
 	device->device_busy--;	/* Decrement device usage counter. */
 
-	if (host->block && host->host_busy == 0) {
-		host_active = NULL;
-
-		/* For block devices "wake_up" is done in end_scsi_request */
-		if (!SCSI_BLK_MAJOR(MAJOR(SCpnt->request.rq_dev))) {
-			struct Scsi_Host *next;
-
-			for (next = host->block; next != host; next = next->block)
-				wake_up(&next->host_wait);
-		}
-	}
-	/*
-	 * Now try and drain the mid-level queue if any commands have been
-	 * inserted.  Check to see whether the queue even has anything in
-	 * it first, as otherwise this is useless overhead.
-	 */
-	if (SCpnt->host->pending_commands != NULL) {
-		scsi_mlqueue_finish(SCpnt->host, SCpnt->device);
-	}
-	wake_up(&host->host_wait);
 
 	/*
 	 * If we have valid sense information, then some kind of recovery
@@ -1821,9 +1671,34 @@
 static void scsi_unregister_host(Scsi_Host_Template *);
 #endif
 
+/*
+ * Function:    scsi_malloc
+ *
+ * Purpose:     Allocate memory from the DMA-safe pool.
+ *
+ * Arguments:   len       - amount of memory we need.
+ *
+ * Lock status: No locks assumed to be held.  This function is SMP-safe.
+ *
+ * Returns:     Pointer to memory block.
+ *
+ * Notes:       Prior to the new queue code, this function was not SMP-safe.
+ *              This function can only allocate in units of sectors
+ *              (i.e. 512 bytes).
+ *
+ *              We cannot use the normal system allocator becuase we need
+ *              to be able to guarantee that we can process a complete disk
+ *              I/O request without touching the system allocator.  Think
+ *              about it - if the system were heavily swapping, and tried to
+ *              write out a block of memory to disk, and the SCSI code needed
+ *              to allocate more memory in order to be able to write the
+ *              data to disk, you would wedge the system.
+ */
 void *scsi_malloc(unsigned int len)
 {
 	unsigned int nbits, mask;
+	unsigned long flags;
+
 	int i, j;
 	if (len % SECTOR_SIZE != 0 || len > PAGE_SIZE)
 		return NULL;
@@ -1831,6 +1706,8 @@
 	nbits = len >> 9;
 	mask = (1 << nbits) - 1;
 
+	spin_lock_irqsave(&allocator_request_lock, flags);
+
 	for (i = 0; i < dma_sectors / SECTORS_PER_PAGE; i++)
 		for (j = 0; j <= SECTORS_PER_PAGE - nbits; j++) {
 			if ((dma_malloc_freelist[i] & (mask << j)) == 0) {
@@ -1840,15 +1717,37 @@
 				SCSI_LOG_MLQUEUE(3, printk("SMalloc: %d %p [From:%p]\n", len, dma_malloc_pages[i] + (j << 9)));
 				printk("SMalloc: %d %p [From:%p]\n", len, dma_malloc_pages[i] + (j << 9));
 #endif
+				spin_unlock_irqrestore(&allocator_request_lock, flags);
 				return (void *) ((unsigned long) dma_malloc_pages[i] + (j << 9));
 			}
 		}
+	spin_unlock_irqrestore(&allocator_request_lock, flags);
 	return NULL;		/* Nope.  No more */
 }
 
+/*
+ * Function:    scsi_free
+ *
+ * Purpose:     Free memory into the DMA-safe pool.
+ *
+ * Arguments:   ptr       - data block we are freeing.
+ *              len       - size of block we are freeing.
+ *
+ * Lock status: No locks assumed to be held.  This function is SMP-safe.
+ *
+ * Returns:     Nothing
+ *
+ * Notes:       This function *must* only be used to free memory
+ *              allocated from scsi_malloc().
+ *
+ *              Prior to the new queue code, this function was not SMP-safe.
+ *              This function can only allocate in units of sectors
+ *              (i.e. 512 bytes).
+ */
 int scsi_free(void *obj, unsigned int len)
 {
 	unsigned int page, sector, nbits, mask;
+	unsigned long flags;
 
 #ifdef DEBUG
 	unsigned long ret = 0;
@@ -1862,6 +1761,8 @@
 	SCSI_LOG_MLQUEUE(3, printk("SFree: %p %d\n", obj, len));
 #endif
 
+	spin_lock_irqsave(&allocator_request_lock, flags);
+
 	for (page = 0; page < dma_sectors / SECTORS_PER_PAGE; page++) {
 		unsigned long page_addr = (unsigned long) dma_malloc_pages[page];
 		if ((unsigned long) obj >= page_addr &&
@@ -1884,6 +1785,7 @@
 			}
 			scsi_dma_free_sectors += nbits;
 			dma_malloc_freelist[page] &= ~(mask << sector);
+			spin_unlock_irqrestore(&allocator_request_lock, flags);
 			return 0;
 		}
 	}
@@ -1934,10 +1836,13 @@
 
 void scsi_build_commandblocks(Scsi_Device * SDpnt)
 {
+	unsigned long flags;
 	struct Scsi_Host *host = SDpnt->host;
 	int j;
 	Scsi_Cmnd *SCpnt;
 
+	spin_lock_irqsave(&device_request_lock, flags);
+
 	if (SDpnt->queue_depth == 0)
 		SDpnt->queue_depth = host->cmd_per_lun;
 	SDpnt->device_queue = NULL;
@@ -1977,8 +1882,10 @@
 		       SDpnt->queue_depth, j);
 		SDpnt->queue_depth = j;
 		SDpnt->has_cmdblocks = (0 != j);
-	} else
+	} else {
 		SDpnt->has_cmdblocks = 1;
+	}
+	spin_unlock_irqrestore(&device_request_lock, flags);
 }
 
 #ifndef MODULE			/* { */
@@ -2160,7 +2067,7 @@
 			}
 		}
 
-	stop_output:
+	      stop_output:
 		*start = buffer + (offset - begin);	/* Start of wanted data */
 		len -= (offset - begin);	/* Start slop */
 		if (len > length)
@@ -2374,6 +2281,7 @@
 			if (HBA_ptr->host_queue == scd) {
 				HBA_ptr->host_queue = scd->next;
 			}
+			blk_cleanup_queue(&scd->request_queue);
 			scsi_init_free((char *) scd, sizeof(Scsi_Device));
 		} else {
 			return (-EBUSY);
@@ -2385,13 +2293,27 @@
 #endif
 
 /*
- * Go through the device list and recompute the most appropriate size
- * for the dma pool.  Then grab more memory (as required).
+ * Function:    resize_dma_pool
+ *
+ * Purpose:     Ensure that the DMA pool is sufficiently large to be
+ *              able to guarantee that we can always process I/O requests
+ *              without calling the system allocator.
+ *
+ * Arguments:   None.
+ *
+ * Lock status: No locks assumed to be held.  This function is SMP-safe.
+ *
+ * Returns:     Nothing
+ *
+ * Notes:       Prior to the new queue code, this function was not SMP-safe.
+ *              Go through the device list and recompute the most appropriate
+ *              size for the dma pool.  Then grab more memory (as required).
  */
 static void resize_dma_pool(void)
 {
 	int i, k;
 	unsigned long size;
+	unsigned long flags;
 	struct Scsi_Host *shpnt;
 	struct Scsi_Host *host = NULL;
 	Scsi_Device *SDpnt;
@@ -2401,6 +2323,8 @@
 	unsigned char **new_dma_malloc_pages = NULL;
 	int out_of_space = 0;
 
+	spin_lock_irqsave(&allocator_request_lock, flags);
+
 	if (!scsi_hostlist) {
 		/*
 		 * Free up the DMA pool.
@@ -2420,6 +2344,7 @@
 		dma_malloc_freelist = NULL;
 		dma_sectors = 0;
 		scsi_dma_free_sectors = 0;
+		spin_unlock_irqrestore(&allocator_request_lock, flags);
 		return;
 	}
 	/* Next, check to see if we need to extend the DMA buffer pool */
@@ -2566,6 +2491,8 @@
 	dma_sectors = new_dma_sectors;
 	scsi_need_isa_buffer = new_need_isa_buffer;
 
+	spin_unlock_irqrestore(&allocator_request_lock, flags);
+
 #ifdef DEBUG_INIT
 	printk("resize_dma_pool: dma free sectors   = %d\n", scsi_dma_free_sectors);
 	printk("resize_dma_pool: dma sectors        = %d\n", dma_sectors);
@@ -2668,8 +2595,6 @@
 		printk("scsi : %d host%s.\n", next_scsi_host,
 		       (next_scsi_host == 1) ? "" : "s");
 
-		scsi_make_blocked_list();
-
 		/* The next step is to call scan_scsis here.  This generates the
 		 * Scsi_Devices entries
 		 */
@@ -2881,6 +2806,7 @@
 			}
 			SDpnt->has_cmdblocks = 0;
 
+			blk_cleanup_queue(&SDpnt->request_queue);
 			/* Next free up the Scsi_Device structures for this host */
 			shpnt->host_queue = SDpnt->next;
 			scsi_init_free((char *) SDpnt, sizeof(Scsi_Device));
@@ -2940,7 +2866,6 @@
 	       (scsi_memory_upper_value - scsi_init_memory_start) / 1024);
 #endif
 
-	scsi_make_blocked_list();
 
 	/* There were some hosts that were loaded at boot time, so we cannot
 	   do any more than this */
@@ -3175,12 +3100,11 @@
 	printk("Dump of scsi host parameters:\n");
 	i = 0;
 	for (shpnt = scsi_hostlist; shpnt; shpnt = shpnt->next) {
-		printk(" %d %d %d : %d %p\n",
+		printk(" %d %d %d : %d\n",
 		       shpnt->host_failed,
 		       shpnt->host_busy,
 		       atomic_read(&shpnt->host_active),
-		       shpnt->host_blocked,
-		       shpnt->pending_commands);
+		       shpnt->host_blocked);
 
 	}
 
@@ -3226,10 +3150,10 @@
 			/* Now dump the request lists for each block device */
 			printk("Dump of pending block device requests\n");
 			for (i = 0; i < MAX_BLKDEV; i++) {
-				if (blk_dev[i].current_request) {
+				if (blk_dev[i].request_queue.current_request) {
 					struct request *req;
 					printk("%d: ", i);
-					req = blk_dev[i].current_request;
+					req = blk_dev[i].request_queue.current_request;
 					while (req) {
 						printk("(%s %d %ld %ld %ld) ",
 						   kdevname(req->rq_dev),
@@ -3244,7 +3168,7 @@
 			}
 		}
 	}
-	/* printk("wait_for_request = %p\n", &wait_for_request); */
+	printk("wait_for_request = %p\n", &wait_for_request);
 #endif	/* CONFIG_SCSI_LOGGING */ /* } */
 #endif				/* CONFIG_PROC_FS */
 }
diff -u -r linux.clean/drivers/scsi/scsi.h linux.new2/drivers/scsi/scsi.h
--- linux.clean/drivers/scsi/scsi.h	Wed Oct 20 16:36:45 1999
+++ linux.new2/drivers/scsi/scsi.h	Sun Nov 14 09:25:47 1999
@@ -1,13 +1,13 @@
 /*
  *  scsi.h Copyright (C) 1992 Drew Eckhardt 
- *         Copyright (C) 1993, 1994, 1995 Eric Youngdale
+ *         Copyright (C) 1993, 1994, 1995, 1998, 1999 Eric Youngdale
  *  generic SCSI package header file by
  *      Initial versions: Drew Eckhardt
  *      Subsequent revisions: Eric Youngdale
  *
  *  <drew@colorado.edu>
  *
- *       Modified by Eric Youngdale eric@aib.com to
+ *       Modified by Eric Youngdale eric@andante.org to
  *       add scatter-gather, multiple outstanding request, and other
  *       enhancements.
  */
@@ -49,6 +49,21 @@
 #endif
 
 /*
+ * Used for debugging the new queueing code.  We want to make sure
+ * that the lock state is consistent with design.  Only do this in
+ * the user space simulator.
+ */
+#define ASSERT_LOCK(_LOCK, _COUNT)
+
+#if defined(__SMP__) && defined(CONFIG_USER_DEBUG)
+#undef ASSERT_LOCK
+#define ASSERT_LOCK(_LOCK,_COUNT)       \
+        { if( (_LOCK)->lock != _COUNT )   \
+                panic("Lock count inconsistent %s %d\n", __FILE__, __LINE__); \
+                                                                                       }
+#endif
+
+/*
  *  Use these to separate status msg and our bytes
  *
  *  These are set by:
@@ -379,23 +394,33 @@
 extern void scsi_sleep(int);
 
 /*
+ * Prototypes for functions in scsi_lib.c
+ */
+extern void initialize_merge_fn(Scsi_Device * SDpnt);
+extern void scsi_request_fn(request_queue_t * q);
+
+extern int scsi_insert_special_cmd(Scsi_Cmnd * SCpnt, int);
+extern int scsi_dispatch_cmd(Scsi_Cmnd * SCpnt);
+
+/*
  *  scsi_abort aborts the current command that is executing on host host.
  *  The error code, if non zero is returned in the host byte, otherwise 
  *  DID_ABORT is returned in the hostbyte.
  */
 
 extern void scsi_do_cmd(Scsi_Cmnd *, const void *cmnd,
-			 void *buffer, unsigned bufflen, 
-			 void (*done)(struct scsi_cmnd *),
-			 int timeout, int retries);
-
-extern void scsi_wait_cmd (Scsi_Cmnd *, const void *cmnd ,
 			void *buffer, unsigned bufflen,
 			void (*done) (struct scsi_cmnd *),
 			int timeout, int retries);
 
+extern void scsi_wait_cmd(Scsi_Cmnd *, const void *cmnd,
+			  void *buffer, unsigned bufflen,
+			  void (*done) (struct scsi_cmnd *),
+			  int timeout, int retries);
 
-extern Scsi_Cmnd *scsi_allocate_device(struct request **, Scsi_Device *, int);
+extern void scsi_request_fn(request_queue_t * q);
+
+extern Scsi_Cmnd *scsi_allocate_device(Scsi_Device *, int);
 
 extern Scsi_Cmnd *scsi_request_queueable(struct request *, Scsi_Device *);
 
@@ -426,9 +451,10 @@
 	wait_queue_head_t device_wait;	/* Used to wait if
 					   device is busy */
 	struct Scsi_Host *host;
+	request_queue_t request_queue;
 	volatile unsigned short device_busy;	/* commands actually active on low-level */
-	void (*scsi_request_fn) (void);		/* Used to jumpstart things after an 
-						   * ioctl */
+	int (*scsi_init_io_fn) (Scsi_Cmnd *);	/* Used to initialize
+						   new request */
 	Scsi_Cmnd *device_queue;	/* queue of SCSI Command structures */
 
 /* public: */
@@ -436,6 +462,8 @@
 
 	unsigned int manufacturer;	/* Manufacturer of device, for using 
 					 * vendor-specific cmd's */
+	unsigned sector_size;	/* size in bytes */
+
 	int attached;		/* # of high level drivers attached to 
 				 * this */
 	int access_count;	/* Count of open channels/mounts */
@@ -473,6 +501,10 @@
 	unsigned expecting_cc_ua:1;	/* Expecting a CHECK_CONDITION/UNIT_ATTN
 					 * because we did a bus reset. */
 	unsigned device_blocked:1;	/* Device returned QUEUE_FULL. */
+	unsigned ten:1;		/* support ten byte read / write */
+	unsigned remap:1;	/* support remapping  */
+	unsigned starved:1;	/* unable to process commands because
+				   host busy */
 };
 
 
@@ -575,16 +607,16 @@
 				   reconnects.   Probably == sector
 				   size */
 
-	int	resid;		/* Number of bytes requested to be
+	int resid;		/* Number of bytes requested to be
 				   transferred less actual number
 				   transferred (0 if not supported) */
 
 	struct request request;	/* A copy of the command we are
 				   working on */
 
-	unsigned char sense_buffer[64];  /* obtained by REQUEST SENSE when
-					    CHECK CONDITION is received on
-					    original command (auto-sense) */
+	unsigned char sense_buffer[64];		/* obtained by REQUEST SENSE when
+						   CHECK CONDITION is received on
+						   original command (auto-sense) */
 
 	unsigned flags;
 
@@ -628,6 +660,14 @@
 	unsigned long pid;	/* Process ID, starts at 0 */
 };
 
+/*
+ *  Flag bits for the internal_timeout array
+ */
+#define NORMAL_TIMEOUT 0
+#define IN_ABORT  1
+#define IN_RESET  2
+#define IN_RESET2 4
+#define IN_RESET3 8
 
 /*
  * Definitions and prototypes used for scsi mid-level queue.
@@ -638,60 +678,15 @@
 extern int scsi_mlqueue_insert(Scsi_Cmnd * cmd, int reason);
 extern int scsi_mlqueue_finish(struct Scsi_Host *host, Scsi_Device * device);
 
+extern Scsi_Cmnd *scsi_end_request(Scsi_Cmnd * SCpnt, int uptodate,
+				   int sectors);
+
+extern void scsi_io_completion(Scsi_Cmnd * SCpnt, int good_sectors,
+			       int block_sectors);
+
 
 #if defined(MAJOR_NR) && (MAJOR_NR != SCSI_TAPE_MAJOR)
 #include "hosts.h"
-
-static Scsi_Cmnd *end_scsi_request(Scsi_Cmnd * SCpnt, int uptodate, int sectors)
-{
-	struct request *req;
-	struct buffer_head *bh;
-
-	req = &SCpnt->request;
-	req->errors = 0;
-	if (!uptodate) {
-		printk(DEVICE_NAME " I/O error: dev %s, sector %lu\n",
-		       kdevname(req->rq_dev), req->sector);
-	}
-	do {
-		if ((bh = req->bh) != NULL) {
-			req->bh = bh->b_reqnext;
-			req->nr_sectors -= bh->b_size >> 9;
-			req->sector += bh->b_size >> 9;
-			bh->b_reqnext = NULL;
-			bh->b_end_io(bh, uptodate);
-			sectors -= bh->b_size >> 9;
-			if ((bh = req->bh) != NULL) {
-				req->current_nr_sectors = bh->b_size >> 9;
-				if (req->nr_sectors < req->current_nr_sectors) {
-					req->nr_sectors = req->current_nr_sectors;
-					printk("end_scsi_request: buffer-list destroyed\n");
-				}
-			}
-		}
-	} while (sectors && bh);
-	if (req->bh) {
-		req->buffer = bh->b_data;
-		return SCpnt;
-	}
-	DEVICE_OFF(req->rq_dev);
-	if (req->sem != NULL) {
-		up(req->sem);
-	}
-	add_blkdev_randomness(MAJOR(req->rq_dev));
-
-	if (SCpnt->host->block) {
-		struct Scsi_Host *next;
-
-		for (next = SCpnt->host->block; next != SCpnt->host;
-		     next = next->block)
-			wake_up(&next->host_wait);
-	}
-	wake_up(&wait_for_request);
-	wake_up(&SCpnt->device->device_wait);
-	scsi_release_command(SCpnt);
-	return NULL;
-}
 
 
 /* This is just like INIT_REQUEST, but we need to be aware of the fact
diff -u -r linux.clean/drivers/scsi/scsi_debug.c linux.new2/drivers/scsi/scsi_debug.c
--- linux.clean/drivers/scsi/scsi_debug.c	Sun Oct 17 12:32:57 1999
+++ linux.new2/drivers/scsi/scsi_debug.c	Sun Nov 14 09:35:30 1999
@@ -41,14 +41,17 @@
 
 #define NR_HOSTS_PRESENT 1
 #define NR_FAKE_DISKS   3
-#define N_HEAD          32
-#define N_SECTOR        64
-#define DISK_READONLY(TGT)      (1)
+#define N_HEAD          255
+#define N_SECTOR        63
+#define N_CYLINDER      524
+#define DISK_READONLY(TGT)      (0)
 #define DISK_REMOVEABLE(TGT)    (1)
+#define DEVICE_TYPE(TGT) (TGT == 2 ? TYPE_TAPE : TYPE_DISK);
+
 
 /* Do not attempt to use a timer to simulate a real disk with latency */
 /* Only use this in the actual kernel, not in the simulator. */
-/* #define IMMEDIATE */
+#define IMMEDIATE
 
 /* Skip some consistency checking.  Good for benchmarking */
 #define SPEEDY
@@ -65,11 +68,15 @@
 #define START_PARTITION 4
 
 /* Time to wait before completing a command */
-#define DISK_SPEED     (HZ/10)   /* 100ms */
-#define CAPACITY (0x80000)
+#define DISK_SPEED     (HZ/10)	/* 100ms */
+#define CAPACITY (N_HEAD * N_SECTOR * N_CYLINDER)
+#define SIZE(TGT) (TGT == 2 ? 2248 : 512)
 
 static int starts[] =
-{N_HEAD, N_HEAD * N_SECTOR, 50000, CAPACITY, 0};
+{N_SECTOR,
+ N_HEAD * N_SECTOR,		/* Single cylinder */
+ N_HEAD * N_SECTOR * 4,
+ CAPACITY, 0};
 static int npart = 0;
 
 #include "scsi_debug.h"
@@ -119,21 +126,25 @@
 
 typedef void (*done_fct_t) (Scsi_Cmnd *);
 
-static volatile done_fct_t do_done[SCSI_DEBUG_MAILBOXES] = {NULL,};
+static volatile done_fct_t do_done[SCSI_DEBUG_MAILBOXES] =
+{NULL,};
 
 static void scsi_debug_intr_handle(unsigned long);
 
 static struct timer_list timeout[SCSI_DEBUG_MAILBOXES];
 
-Scsi_Cmnd *SCint[SCSI_DEBUG_MAILBOXES]  = {NULL,};
-static char SCrst[SCSI_DEBUG_MAILBOXES] = {0,};
+Scsi_Cmnd *SCint[SCSI_DEBUG_MAILBOXES] =
+{NULL,};
+static char SCrst[SCSI_DEBUG_MAILBOXES] =
+{0,};
 
 /*
  * Semaphore used to simulate bus lockups.
  */
 static int scsi_debug_lockup = 0;
 
-static char sense_buffer[128] = {0,};
+static char sense_buffer[128] =
+{0,};
 
 static void scsi_dump(Scsi_Cmnd * SCpnt, int flag)
 {
@@ -249,6 +260,10 @@
 		SCpnt->result = 0;
 		done(SCpnt);
 		return 0;
+	case START_STOP:
+		SCSI_LOG_LLQUEUE(3, printk("START_STOP\n"));
+		scsi_debug_errsts = 0;
+		break;
 	case ALLOW_MEDIUM_REMOVAL:
 		if (cmd[4]) {
 			SCSI_LOG_LLQUEUE(2, printk("Medium removal inhibited..."));
@@ -260,7 +275,7 @@
 	case INQUIRY:
 		SCSI_LOG_LLQUEUE(3, printk("Inquiry...(%p %d)\n", buff, bufflen));
 		memset(buff, 0, bufflen);
-		buff[0] = TYPE_DISK;
+		buff[0] = DEVICE_TYPE(target);
 		buff[1] = DISK_REMOVEABLE(target) ? 0x80 : 0;	/* Removable disk */
 		buff[2] = 1;
 		buff[4] = 33 - 5;
@@ -284,7 +299,10 @@
 		buff[1] = (CAPACITY >> 16) & 0xff;
 		buff[2] = (CAPACITY >> 8) & 0xff;
 		buff[3] = CAPACITY & 0xff;
-		buff[6] = 2;	/* 512 byte sectors */
+		buff[4] = 0;
+		buff[5] = 0;
+		buff[6] = (SIZE(target) >> 8) & 0xff;	/* 512 byte sectors */
+		buff[7] = SIZE(target) & 0xff;
 		scsi_debug_errsts = 0;
 		break;
 	case READ_10:
@@ -334,15 +352,23 @@
 				p = (struct partition *) (buff + 0x1be);
 				i = 0;
 				while (starts[i + 1]) {
+					int start_cyl, end_cyl;
+
+					start_cyl = starts[i] / N_HEAD / N_SECTOR;
+					end_cyl = (starts[i + 1] - 1) / N_HEAD / N_SECTOR;
+					p->boot_ind = 0;
+
+					p->head = (i == 0 ? 1 : 0);
+					p->sector = 1 | ((start_cyl >> 8) << 6);
+					p->cyl = (start_cyl & 0xff);
+
+					p->end_head = N_HEAD - 1;
+					p->end_sector = N_SECTOR | ((end_cyl >> 8) << 6);
+					p->end_cyl = (end_cyl & 0xff);
+
 					p->start_sect = starts[i];
 					p->nr_sects = starts[i + 1] - starts[i];
 					p->sys_ind = 0x81;	/* Linux partition */
-					p->head = (i == 0 ? 1 : 0);
-					p->sector = 1;
-					p->cyl = starts[i] / N_HEAD / N_SECTOR;
-					p->end_head = N_HEAD - 1;
-					p->end_sector = N_SECTOR;
-					p->end_cyl = starts[i + 1] / N_HEAD / N_SECTOR;
 					p++;
 					i++;
 				};
@@ -472,6 +498,8 @@
 #ifdef IMMEDIATE
 	if (!scsi_debug_lockup) {
 		SCpnt->result = scsi_debug_errsts;
+		SCint[i] = SCpnt;
+		do_done[i] = done;
 		scsi_debug_intr_handle(i);	/* No timer - do this one right away */
 	}
 	restore_flags(flags);
@@ -596,7 +624,7 @@
 	int size = disk->capacity;
 	info[0] = N_HEAD;
 	info[1] = N_SECTOR;
-	info[2] = (size + 2047) >> 11;
+	info[2] = N_CYLINDER;
 	if (info[2] >= 1024)
 		info[2] = 1024;
 	return 0;
@@ -690,6 +718,21 @@
 
 	return (len);
 }
+
+#ifdef CONFIG_USER_DEBUG
+/*
+ * This is a hack for the user space emulator.  It allows us to
+ * "insert" arbitrary numbers of additional drivers.
+ */
+void *scsi_debug_get_handle(void)
+{
+	static Scsi_Host_Template driver_copy = SCSI_DEBUG;
+	void *rtn;
+	rtn = kmalloc(sizeof(driver_copy), GFP_ATOMIC);
+	memcpy(rtn, (void *) &driver_copy, sizeof(driver_copy));
+	return rtn;
+}
+#endif
 
 #ifdef MODULE
 /* Eventually this will go into an include file, but this will be later */
diff -u -r linux.clean/drivers/scsi/scsi_debug.h linux.new2/drivers/scsi/scsi_debug.h
--- linux.clean/drivers/scsi/scsi_debug.h	Sun Sep 12 15:26:06 1999
+++ linux.new2/drivers/scsi/scsi_debug.h	Sun Nov 14 08:55:35 1999
@@ -34,9 +34,9 @@
 		    bios_param:        scsi_debug_biosparam,	\
 		    can_queue:         SCSI_DEBUG_CANQUEUE,	\
 		    this_id:           7,			\
-		    sg_tablesize:      SG_ALL,			\
+		    sg_tablesize:      16,			\
 		    cmd_per_lun:       3,			\
-		    unchecked_isa_dma: 1,			\
+		    unchecked_isa_dma: 0,			\
 		    use_clustering:    ENABLE_CLUSTERING,	\
 		    use_new_eh_code:   1,			\
 }
diff -u -r linux.clean/drivers/scsi/scsi_error.c linux.new2/drivers/scsi/scsi_error.c
--- linux.clean/drivers/scsi/scsi_error.c	Sun Oct 17 15:45:17 1999
+++ linux.new2/drivers/scsi/scsi_error.c	Sun Nov 14 08:55:35 1999
@@ -35,11 +35,13 @@
 #include "hosts.h"
 #include "constants.h"
 
-#ifdef MODULE
+/*
+ * We must always allow SHUTDOWN_SIGS.  Even if we are not a module,
+ * the host drivers that we are using may be loaded as modules, and
+ * when we unload these,  we need to ensure that the error handler thread
+ * can be shut down.
+ */
 #define SHUTDOWN_SIGS	(sigmask(SIGKILL)|sigmask(SIGINT)|sigmask(SIGTERM))
-#else
-#define SHUTDOWN_SIGS	(0UL)
-#endif
 
 #ifdef DEBUG
 #define SENSE_TIMEOUT SCSI_TIMEOUT
@@ -128,7 +130,9 @@
  *
  * Arguments:   SCset   - command that we are canceling timer for.
  *
- * Returns:     Amount of time remaining before command would have timed out.
+ * Returns:     1 if we were able to detach the timer.  0 if we
+ *              blew it, and the timer function has already started
+ *              to run.
  *
  * Notes:       This should be turned into an inline function.
  */
@@ -136,8 +140,7 @@
 {
 	int rtn;
 
-	rtn = jiffies - SCset->eh_timeout.expires;
-	del_timer(&SCset->eh_timeout);
+	rtn = del_timer(&SCset->eh_timeout);
 
 	SCSI_LOG_ERROR_RECOVERY(5, printk("Clearing timer for command %p\n", SCset));
 
@@ -563,10 +566,7 @@
 
 	add_timer(&timer);
 
-	spin_unlock_irq(&io_request_lock);
 	down(&sem);
-	spin_lock_irq(&io_request_lock);
-
 	del_timer(&timer);
 }
 
@@ -811,7 +811,9 @@
 	 * If we had a successful bus reset, mark the command blocks to expect
 	 * a condition code of unit attention.
 	 */
+	spin_unlock_irq(&io_request_lock);
 	scsi_sleep(BUS_RESET_SETTLE_TIME);
+	spin_lock_irq(&io_request_lock);
 	if (SCpnt->eh_state == SUCCESS) {
 		Scsi_Device *SDloop;
 		for (SDloop = SCpnt->host->host_queue; SDloop; SDloop = SDloop->next) {
@@ -854,7 +856,9 @@
 	 * If we had a successful host reset, mark the command blocks to expect
 	 * a condition code of unit attention.
 	 */
+	spin_unlock_irq(&io_request_lock);
 	scsi_sleep(HOST_RESET_SETTLE_TIME);
+	spin_lock_irq(&io_request_lock);
 	if (SCpnt->eh_state == SUCCESS) {
 		Scsi_Device *SDloop;
 		for (SDloop = SCpnt->host->host_queue; SDloop; SDloop = SDloop->next) {
@@ -1172,6 +1176,7 @@
 STATIC void scsi_restart_operations(struct Scsi_Host *host)
 {
 	Scsi_Device *SDpnt;
+	unsigned long flags;
 
 	/*
 	 * Next free up anything directly waiting upon the host.  This will be
@@ -1183,18 +1188,23 @@
 	wake_up(&host->host_wait);
 
 	/*
-	 * Finally, block devices need an extra kick in the pants.  This is because
-	 * the request queueing mechanism may have queued lots of pending requests
-	 * and there won't be a process waiting in a place where we can simply wake
-	 * it up.  Thus we simply go through and call the request function to goose
-	 * the various top level drivers and get things moving again.
+	 * Finally we need to re-initiate requests that may be pending.  We will
+	 * have had everything blocked while error handling is taking place, and
+	 * now that error recovery is done, we will need to ensure that these
+	 * requests are started.
 	 */
+	spin_lock_irqsave(&io_request_lock, flags);
 	for (SDpnt = host->host_queue; SDpnt; SDpnt = SDpnt->next) {
-		SCSI_LOG_ERROR_RECOVERY(5, printk("Calling request function to restart things...\n"));
-
-		if (SDpnt->scsi_request_fn != NULL)
-			(*SDpnt->scsi_request_fn) ();
+		request_queue_t *q;
+		if ((host->can_queue > 0 && (host->host_busy >= host->can_queue))
+		    || (host->host_blocked)
+		    || (SDpnt->device_blocked)) {
+			break;
+		}
+		q = &SDpnt->request_queue;
+		q->request_fn(q);
 	}
+	spin_unlock_irqrestore(&io_request_lock, flags);
 }
 
 /*
@@ -1524,7 +1534,9 @@
 						 * Due to the spinlock, we will never get out of this
 						 * loop without a proper wait (DB)
 						 */
+						spin_unlock_irq(&io_request_lock);
 						scsi_sleep(1 * HZ);
+						spin_lock_irq(&io_request_lock);
 
 						goto next_device;
 					}
@@ -1617,7 +1629,9 @@
 				 * Due to the spinlock, we will never get out of this
 				 * loop without a proper wait. (DB)
 				 */
+				spin_unlock_irq(&io_request_lock);
 				scsi_sleep(1 * HZ);
+				spin_lock_irq(&io_request_lock);
 
 				goto next_device2;
 			}
@@ -1768,11 +1782,11 @@
 	lock_kernel();
 
 	/*
-	 *	Flush resources
+	 *    Flush resources
 	 */
-	 
+
 	daemonize();
-	
+
 	/*
 	 * Set the name of this process.
 	 */
